/*
Copyright (c) 2004 The Regents of the University of California. All Rights
Reserved. Permission to use, copy, modify, and distribute this  software
and its documentation for educational, research and non-profit purposes,
without fee, and without a written agreement is hereby granted, provided
that the above copyright notice, this paragraph and the following two
paragraphs appear in all copies. This software program and documentation
are copyrighted  by The Regents of the University of California ("The
University of California").

THE SOFTWARE PROGRAM AND DOCUMENTATION ARE SUPPLIED "AS IS," WITHOUT ANY
ACCOMPANYING SERVICES FROM THE UNIVERSITY OF CALFORNIA. FURTHERMORE, THE
UNIVERSITY OF CALIFORNIA DOES NOT WARRANT THAT THE OPERATION OF THE
PROGRAM  WILL BE UNINTERRUPTED OR ERROR-FREE. THE END-USER UNDERSTANDS
THAT THE PROGRAM  WAS DEVELOPED FOR RESEARCH PURPOSES AND IS ADVISED NOT
TO RELY EXCLUSIVELY  ON THE PROGRAM FOR ANY REASON.

IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING
LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
DOCUMENTATION,  EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF
THE POSSIBILITY OF SUCH DAMAGES. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY
DISCLAIMS ANY  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE
SOFTWARE PROVIDED  HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR  MODIFICATIONS.
*/


#ifndef	B_COMM_DEF_H
#define	B_COMM_DEF_H

#define	COUNT_TYPE	unsigned char
#define	DATA_TYPE	unsigned short int

#define	PACKET_SIZE	89

#define	PREAMBLE_SIZE 6
#define	PREAMBLE_CONTENT "\x00\x00\xb4\x8a\x8b\x3f"

#define	ACK_SIZE	(PREAMBLE_SIZE + 2)

#define	TYPECODE_OFFSET	PREAMBLE_SIZE
#define	OPCODE_OFFSET	(PREAMBLE_SIZE + 1)
#define	COUNT_OFFSET	(PREAMBLE_SIZE + 2)
#define	DATA_OFFSET	(COUNT_OFFSET + sizeof(COUNT_TYPE))

#define	DATA_TYPE_MASK	'\x0f'
#define	MAX_TICK	'\x00'
#define	PRESCALAR	'\x01'
#define	ENDIAN	'\x02'
#define	DEBUG_FLAG1	'\x03'
#define	DEBUG_FLAG2	'\x04'

//#define	VOLTAGE_REF0	'\x03'
//#define	VOLTAGE_REF_HI	'\x04'
//#define	VOLTAGE_REF_LO	'\x05'
#define	VOLTAGE	'\x06'
#define	AVG_CURRENT	'\x05'
#define	CURRENT	'\x07'
#define	TIME	'\x08'

#define	COMM_TYPE_MASK	'\xf0'
#define	SEND	'\x80'
#define	RECV	'\x00'
#define	SEND_RECV_MASK	'\x80'
#define	ACK	'\x40'
#define	NOACK	'\x00'
#define	ACK_NOACK_MASK	'\x40'
#define	STOP	'\x00'
#define	CONTINUE	'\x20'
#define	STOP_CONTINUE_MASK '\x20'

#define	MEASURE_VOLTAGE	'\x80'
#define	MEASURE_CURRENT	'\x40'
#define	EMULATE_VOLTAGE	'\x10'
#define	MEASURE_AVG_CURRENT	'\x20'
#define	NOP '\x00'

#define	ITEM_COUNT_PER_PACKET ((PACKET_SIZE - DATA_OFFSET) / sizeof(DATA_TYPE))

#endif

