/*
Copyright (c) 2004 The Regents of the University of California. All Rights
Reserved. Permission to use, copy, modify, and distribute this  software
and its documentation for educational, research and non-profit purposes,
without fee, and without a written agreement is hereby granted, provided
that the above copyright notice, this paragraph and the following two
paragraphs appear in all copies. This software program and documentation
are copyrighted  by The Regents of the University of California ("The
University of California").

THE SOFTWARE PROGRAM AND DOCUMENTATION ARE SUPPLIED "AS IS," WITHOUT ANY
ACCOMPANYING SERVICES FROM THE UNIVERSITY OF CALFORNIA. FURTHERMORE, THE
UNIVERSITY OF CALIFORNIA DOES NOT WARRANT THAT THE OPERATION OF THE
PROGRAM  WILL BE UNINTERRUPTED OR ERROR-FREE. THE END-USER UNDERSTANDS
THAT THE PROGRAM  WAS DEVELOPED FOR RESEARCH PURPOSES AND IS ADVISED NOT
TO RELY EXCLUSIVELY  ON THE PROGRAM FOR ANY REASON.

IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING
LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
DOCUMENTATION,  EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF
THE POSSIBILITY OF SUCH DAMAGES. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY
DISCLAIMS ANY  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE
SOFTWARE PROVIDED  HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR  MODIFICATIONS.
*/


#include <stdio.h>
#include <math.h>

#ifndef	_WIN32
#include <endian.h>
#endif

#include "B_comm.h"

//#define	MAX_POINT	ITEM_COUNT_PER_PACKET	
#define	MAX_POINT	200	

extern	double	sim_voltage[];
extern	double	sim_time[];
extern	int	sim_count;
extern	int	l;

double	vref_adc = 5.0;
double	vref_dac = 5.0;

//double	voffset_adc = -0.03;
double	voffset_adc = 0;
//double	voffset_dac = 0.03;
double	voffset_dac = 0;
//double	coffset_adc = 0.045;
double	coffset_adc = 0;

//double	r_vreg = 0.270;
double	r_vreg = 0;

double	c_factor = 2e3;
double	rc_adc = 10e3;
double	vmax_dac = 4.86;

int	nbit_adc;
int	nbit_dac;
int	dac_shift;

unsigned int	max_adc_value;
unsigned int	max_dac_value;

double	vstep_adc;
double	cstep_adc;
double	vstep_dac;

int	max_tick;
DATA_TYPE	d_max_tick;

double	sim_interval, tick_interval;
double	elapsed_time;

struct	timeval	tv, *p_tv;

double	emu_voltage[MAX_POINT], emu_time[MAX_POINT];
int	emu_voltage_count;

double	mea_voltage[MAX_POINT], mea_current[MAX_POINT], mea_avg_current;
int	mea_voltage_count, mea_current_count;

DATA_TYPE	d_voltage[MAX_POINT], d_time[MAX_POINT], d_current[MAX_POINT], d_avg_current;
DATA_TYPE	d_count;


float	cu0;
int	mc0 = 1;
int	ack = 0;
//extern	int	debug_flag;
int	debug_flag2 = 1;
int	B_debug_flag1 = 0, B_debug_flag2 = 0;
DATA_TYPE	d_debug_flag1, d_debug_flag2;

double prescalar_table[] = {
	0.000,
	0.208e-3,
	0.417e-3,
	0.835e-3,
	1.665e-3,
	3.325e-3,
	6.65e-3,
	13.35e-3,
};

int	prescalar, max_prescalar = 7;
DATA_TYPE	d_prescalar;

int	endian;
DATA_TYPE	d_endian;

extern	int	done;

/*
void	init_handshake(sock_type sock, char *device)
{
	int	dummy;

	while (send_data(sock, device, &d_count, 1, 0, NOP, 1, p_tv) != 0)
	{
		if (done)
			break;
		//if (debug_flag2)
			printf("Error in init_handshake(): send_data()\n");
	}

	return;
}
*/

int	parameter_ok = 0;


void	init_parameter(void)
{
	if (max_tick > MAX_POINT)
		max_tick = MAX_POINT;

	tick_interval = sim_interval / max_tick;
	
	printf("Preset sim_interval = %8.3e\tmax_tick = %d\ttick_interval = %8.3e\n", 
		sim_interval, max_tick, tick_interval);

	for (prescalar = 1; prescalar <= max_prescalar; prescalar ++)
		if (prescalar_table[prescalar] >= tick_interval)
			break;

	if (prescalar > max_prescalar)
		prescalar = max_prescalar;

	tick_interval = prescalar_table[prescalar];
	max_tick = ceil(sim_interval / tick_interval);

	if (max_tick > MAX_POINT)
		max_tick = MAX_POINT;

	sim_interval = tick_interval * max_tick;

	printf("Adjust sim_interval = %8.3e\tmax_tick = %d\ttick_interval = %8.3e\n", 
		sim_interval, max_tick, tick_interval);
	printf("\tprescalar = %d\n", prescalar);

	tv.tv_sec = (int)sim_interval;
	tv.tv_usec = (int)((sim_interval - tv.tv_sec) * 1.e6);
	p_tv = &tv;
	p_tv = NULL;

	nbit_adc = 10;
	max_adc_value = (1 << nbit_adc) - 1;

	vstep_adc = vref_adc / ((double) max_adc_value);

	cstep_adc = vref_adc / ((double) max_adc_value) * c_factor / rc_adc;

	nbit_dac = 10;
	max_dac_value = (1 << nbit_dac) - 1;
	vstep_dac = vref_dac / ((double) max_dac_value);
	dac_shift = 2;

	// a hack to send a voltage anyway
	
	sim_voltage[0] = 4.1;
	sim_voltage[1] = 4.11;
	sim_time[0] = 0.;
	sim_time[1] = sim_interval;
	sim_count = 2;

	cu0 = mea_avg_current = 0;
	
	elapsed_time = 0.;

	parameter_ok = 1;

	return;
}


int	init_board(sock_type sock, char *device, char opcode)
{
	int	i;
	
#ifndef	_WIN32
	if (__BYTE_ORDER == __LITTLE_ENDIAN)
		endian = 0;
	else
		endian = 1;
#else
	endian = 0;
#endif

	if (endian == 1)
		for (i = 0; i < sizeof(DATA_TYPE); i ++)
			memcpy(&(((char *)&d_endian)[i]), "\x01", 1);	
	else
		d_endian = 0;
	while (send_data(sock, device, &d_endian, 1, ENDIAN, NOP, 1, p_tv) != 0)
	{
		if (done)
			return 1;
		//if (debug_flag2)
			printf("Error in init_emulation(): send_data(ENDIAN)\n");
		//return 1;
	}

	if (B_debug_flag1)
		for (i = 0; i < sizeof(DATA_TYPE); i ++)
			memcpy(&(((char *)&d_debug_flag1)[i]), "\x01", 1);	
	else
		d_debug_flag1 = 0;
	printf("flag1 = %x\n", (int)d_debug_flag1);
	while (send_data(sock, device, &d_debug_flag1, 1, DEBUG_FLAG1, NOP, 1, p_tv) != 0)
	{
		if (done)
			return 1;
		//if (debug_flag2)
			printf("Error in init_emulation(): send_data(DEBUG_FLAG1)\n");
		//return 1;
	}


	if (B_debug_flag2)
		for (i = 0; i < sizeof(DATA_TYPE); i ++)
			memcpy(&(((char *)&d_debug_flag2)[i]), "\x01", 1);	
	else
		d_debug_flag2 = 0;
	printf("flag2 = %x\n", (int)d_debug_flag2);
	while (send_data(sock, device, &d_debug_flag2, 1, DEBUG_FLAG2, NOP, 1, p_tv) != 0)
	{
		if (done)
			return 1;
		//if (debug_flag2)
			printf("Error in init_emulation(): send_data(DEBUG_FLAG2)\n");
		//return 1;
	}

	d_max_tick = (DATA_TYPE)max_tick;
	while (send_data(sock, device, &d_max_tick, 1, MAX_TICK, NOP, 1, p_tv) != 0)
	{
		if (done)
			return 1;
		//if (debug_flag2)
			printf("Error in init_emulation(): send_data(MAX_TICK)\n");
		//return 1;
	}

	d_prescalar = (DATA_TYPE)prescalar;
	while (send_data(sock, device, &d_prescalar, 1, PRESCALAR, opcode, 1, p_tv) != 0)
	{
		if (done)
			return 1;
		//if (debug_flag2)
			printf("Error in init_emulation(): send_data(PRESCALAR)\n");
		//return 2;
	}

	if (debug_flag2)
		printf("init_emulation(): done\n");

	return 0;
}


int	send_voltage(sock_type sock, char *device, char opcode)
{
	float	v, t;
	DATA_TYPE	d_v, d_t;
	int i;

	// manual calibration for iPaq
	//double	a = -14.51, b = 4.55;
	//double	a = -14.31, b = 4.55;
	//for (i = 0; i < sim_count; i ++)
	//	sim_voltage[i] = a + sim_voltage[i] * b;

	/*
	// send v[] for every tick
	emu_voltage_count = max_tick;

	for (i = 0; i < emu_voltage_count; i ++)
	{
		d_voltage[i] = 0;
		emu_voltage[i] = vmax_dac - voffset_dac * vstep_dac;
		emu_time[i] = elapsed_time + i * tick_interval;
	}

	for (i = 0; i < sim_count; i ++)
	{
		v = sim_voltage[i];
		t = sim_time[i];
		d_v = (DATA_TYPE)((vmax_dac - v) / vstep_dac + voffset_dac);
		d_t = (DATA_TYPE)((t - elapsed_time) / tick_interval);

		if ((int)d_t >= max_tick)
			d_t = (DATA_TYPE)(max_tick - 1);

		d_voltage[(int)d_t] = d_v;
		emu_voltage[(int)d_t] = v;
	}
	if (sim_count == 1)
	{
		d_voltage[0] = d_voltage[max_tick - 1] = d_v;
		emu_voltage[0] = emu_voltage[max_tick - 1] = v;
	}

	for (i = 1; i < emu_voltage_count; i ++)
	{
		if (d_voltage[i] == 0)
		{
			d_voltage[i] = d_voltage[i - 1];
			emu_voltage[i] = emu_voltage[i - 1];
		}
	}

	while (send_data(sock, device, d_voltage, emu_voltage_count, VOLTAGE, opcode, 1, p_tv) != 0)
	{
		if (done)
			return 1;
		//if (debug_flag2)
			printf("Error in send_voltage(): send_data(VOLTAGE)\n");
		//return 1;
	}
	*/

	// send (v, t) pair
	emu_voltage_count = 0;
	for (i = 0; i < sim_count; i ++)
	{
		// cu0 updated later
		v = sim_voltage[i];
		t = sim_time[i];
		d_v = ((DATA_TYPE)((vmax_dac - v - voffset_dac - cu0 * r_vreg) / vstep_dac)) << dac_shift;
		d_t = (DATA_TYPE)((t - elapsed_time) / tick_interval);

		if ((int)d_t >= max_tick)
			d_t = (DATA_TYPE)(max_tick - 1);
			//d_t = (DATA_TYPE)(max_tick);
		t = elapsed_time + (int)d_t * tick_interval;

		d_voltage[emu_voltage_count] = d_v;
		d_time[emu_voltage_count] = d_t;
		emu_voltage[emu_voltage_count] = v;
		emu_time[emu_voltage_count] = t;

		if (emu_voltage_count > 0)
		{
			if (d_v == d_voltage[emu_voltage_count - 1])
			{
				;
				//d_time[emu_voltage_count - 1] = d_t;
				//emu_time[emu_voltage_count - 1] = t;
			}
			else 
			{
				if (d_t == d_time[emu_voltage_count - 1])
				{
					d_voltage[emu_voltage_count - 1] = d_v;
					emu_voltage[emu_voltage_count - 1] = v;
				}
				else
					emu_voltage_count ++;
			}
		}
		else
			emu_voltage_count ++;

		if (emu_voltage_count > max_tick)
			emu_voltage_count --;
	}

	d_time[0] = 0;
	emu_time[0] = elapsed_time;

	for (i = emu_voltage_count - 1; i > 0; i --)
		d_time[i] = d_time[i] - d_time[i - 1];

	if (emu_voltage_count == 1)
	{
		emu_voltage_count ++;
		d_time[1] = max_tick - 1;
		//d_time[1] = max_tick;
		emu_time[1] = elapsed_time + d_time[1] * tick_interval; 
		d_voltage[1] = d_voltage[0];
		emu_voltage[1] = emu_voltage[0];
	}


	while (send_data(sock, device, d_voltage, emu_voltage_count, VOLTAGE, NOP, 1, p_tv) != 0)
	{
		if (done)
			return 1;
		//if (debug_flag2)
			printf("Error in send_voltage(): send_data(VOLTAGE)\n");
		//return 1;
	}

	while (send_data(sock, device, d_time, emu_voltage_count, TIME, opcode, 1, p_tv) != 0)
	{
		if (done)
			return 1;
		//if (debug_flag2)
			printf("Error in send_voltage(): send_data(TIME)\n");
		//return 2;
	}

	if (debug_flag2)
	{
		printf("sim_voltage: %d points\n", sim_count);
		for (i = 0; i < sim_count; i ++)
			printf("t = %14.6f\tv = %8.3e\n", sim_time[i], sim_voltage[i]);

		printf("send_voltage(): done with %d points\n", emu_voltage_count);
		for (i = 0; i < emu_voltage_count; i ++)
			printf("t = %14.6f\tv = %8.3e\n", emu_time[i], emu_voltage[i]);
	}

	return 0;
}


int	recv_avg_current(sock_type sock, char *device, char opcode)
{
	int	dummy;
	
	dummy = 1;

	while (1)
	{
		
		while (recv_data(sock, device, &d_avg_current, &dummy, AVG_CURRENT, opcode, 0, p_tv) != 0)
		{
			if (done)
				return 1;
			//if (debug_flag2)
				printf("Error in recv_avg_current(): recv_data(AVG_CURRENT)\n");
			//return 2;
		}
		
		if (d_avg_current > (DATA_TYPE)max_adc_value)
		{
			if (debug_flag2)
			{
				printf("Possible glitch in recv_avg_current(): current = %0X > %0X\n", d_avg_current, max_adc_value);
				d_avg_current &= (DATA_TYPE)max_adc_value;
				printf(" Fixed: current = %0X\n", d_avg_current);
				break;
			}
			else
			{
				continue;
			}
		}
		else
		{
			break;
		}
	}
	
	//mea_avg_current = (int)d_avg_current * vstep_adc / rc_adc + coffset_adc;
	mea_avg_current = (int)d_avg_current * cstep_adc + coffset_adc;

	// remove later
	//while (mea_avg_current > 1)
	//	mea_avg_current /= 10;

	cu0 = mea_avg_current;

	if (debug_flag2)
	{
		printf("recv_avg_current(): done\n");
		printf("t = %14.6f -- %14.6f\tc = %8.3e\n", elapsed_time, elapsed_time + sim_interval, mea_avg_current);
	}
	
	return 0;
}

/*

int	recv_current(sock_type sock, char *device, char opcode)
{
	int	i;
	
	mea_current_count = max_tick;
	while (recv_data(sock, device, d_current, &mea_current_count, CURRENT, opcode, 0, p_tv) != 0)
	{
		if (done)
			return 1;
		//if (debug_flag2)
			printf("Error in recv_current(): recv_data(CURRENT)\n");
		//return 2;
	}

	for (i = 0; i < mea_current_count; i ++)
		mea_current[i] = d_current[i] * vstep_adc / rc_adc + coffset_adc; 
		mea_avg_current = (int)d_avg_current * cstep_adc + coffset_adc;

	//if (debug_flag2)
	{
		printf("recv_current(): done with %d samples\n", mea_current_count);
		for (i = 0; i < mea_current_count; i ++)
			printf("t = %14.6f\tc = %8.3e\n", elapsed_time + i * tick_interval, mea_current[i]);
	}

	return 0;
}


int	recv_voltage(sock_type sock, char *device, char opcode)
{
	int	i;
	
	mea_voltage_count = max_tick;
	while (recv_data(sock, device, d_voltage, &mea_voltage_count, VOLTAGE, opcode, 0, p_tv) != 0)
	{
		if (done)
			return 1;
		//if (debug_flag2)
			printf("Error in recv_voltage(): recv_data(VOLTAGE)\n");
		//return 2;
	}

	for (i = 0; i < mea_voltage_count; i ++)
		mea_voltage[i] = d_voltage[i] * vstep_adc + voffset_adc; 

	//if (debug_flag2)
	{
		printf("recv_voltage(): done with %d samples\n", mea_voltage_count);
		for (i = 0; i < mea_voltage_count; i ++)
			printf("t = %14.6f\tv = %8.3e\n", elapsed_time + i * tick_interval, mea_voltage[i]);
	}

	return 0;
}

*/

int     recv_voltage_current(sock_type sock, char *device, char opcode)
{
	int	r, i, glitch;
	unsigned char	pack[100];
	

	while (1)
	{
		glitch = 0;
		while((r = recv_from_socket(sock, device, pack, 100, p_tv)) <= 0)
		{
			if (done)
				return 1;
			if (r < 0)
				printf("Error in recv_voltage_current(): recv_from_socket\n");
		}
		
		// get v, t
		memcpy(d_voltage, &(pack[DATA_OFFSET]), sizeof(DATA_TYPE));
		memcpy(d_current, &(pack[DATA_OFFSET + sizeof(DATA_TYPE)]), sizeof(DATA_TYPE));
		
		mea_voltage_count = mea_current_count = 1;

		if (d_voltage[0] > (DATA_TYPE)max_adc_value)
		{
			if (debug_flag2)
			{
				printf("Possible glitch in recv_voltage_current(): voltage = %0X > %0X\n", d_voltage[0], max_adc_value);
				d_voltage[0] &= (DATA_TYPE)max_adc_value; 
				printf(" Fixed: voltage = %0X\n", d_voltage[0]);
			}
			else
			{
				glitch = 1;
			}
		}

		if (d_current[0] > (DATA_TYPE)max_adc_value)
		{
			if (debug_flag2)
			{
				printf("Possible glitch in recv_voltage_current(): current = %0X > %0X\n", d_current[0], max_adc_value);
				d_current[0] &= (DATA_TYPE)max_adc_value;
				printf(" Fixed: current = %0X\n", d_current[0]);
			}
			else
			{
				glitch = 1;
			}
		}

		if (!glitch)
			break;
	}

	/*
	// get v, t
	memcpy(d_voltage, &(pack[DATA_OFFSET]), sizeof(DATA_TYPE));
	memcpy(d_current, &(pack[DATA_OFFSET + sizeof(DATA_TYPE)]), sizeof(DATA_TYPE));
	
	mea_voltage_count = mea_current_count = 1;
	
	if (d_voltage[0] > (DATA_TYPE)max_adc_value)
		printf("Possible glitch in recv_voltage_current(): voltage = %0X > %0X\n", d_voltage[0], max_adc_value);
	if (d_current[0] > (DATA_TYPE)max_adc_value)
		printf("Possible glitch in recv_voltage_current(): current = %0X > %0X\n", d_current[0], max_adc_value);

	d_voltage[0] &= (DATA_TYPE)max_adc_value;
	d_current[0] &= (DATA_TYPE)max_adc_value;
	*/

	mea_voltage[0] = d_voltage[0] * vstep_adc + voffset_adc;

	//mea_current[0] = (int)d_current[0] * vstep_adc / rc_adc + coffset_adc;
	mea_current[0] = (int)d_current[0] * cstep_adc + coffset_adc;

	if (debug_flag2)
	{
		printf("recv_voltage_current(): done with 1 samples\n");
		printf("v = %8.3e\tc = % 8.3e\n", mea_voltage[0], mea_current[0]);
	}
	return 0;
}

