/*
Copyright (c) 2004 The Regents of the University of California. All Rights
Reserved. Permission to use, copy, modify, and distribute this  software
and its documentation for educational, research and non-profit purposes,
without fee, and without a written agreement is hereby granted, provided
that the above copyright notice, this paragraph and the following two
paragraphs appear in all copies. This software program and documentation
are copyrighted  by The Regents of the University of California ("The
University of California").

THE SOFTWARE PROGRAM AND DOCUMENTATION ARE SUPPLIED "AS IS," WITHOUT ANY
ACCOMPANYING SERVICES FROM THE UNIVERSITY OF CALFORNIA. FURTHERMORE, THE
UNIVERSITY OF CALIFORNIA DOES NOT WARRANT THAT THE OPERATION OF THE
PROGRAM  WILL BE UNINTERRUPTED OR ERROR-FREE. THE END-USER UNDERSTANDS
THAT THE PROGRAM  WAS DEVELOPED FOR RESEARCH PURPOSES AND IS ADVISED NOT
TO RELY EXCLUSIVELY  ON THE PROGRAM FOR ANY REASON.

IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING
LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
DOCUMENTATION,  EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF
THE POSSIBILITY OF SUCH DAMAGES. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY
DISCLAIMS ANY  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE
SOFTWARE PROVIDED  HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR  MODIFICATIONS.
*/


#ifndef	B_ETHERNET_H
#define	B_ETHERNET_H

#include <stdio.h>
#include <signal.h>
#include <string.h>

#ifdef	_WIN32

#include	<pcap.h>

typedef	pcap_t * sock_type;
//#define	sock_type	pcap_t *


#else

#include <sys/socket.h>
#include <linux/if_arp.h>
#include <sys/ioctl.h>
#include <fcntl.h>
//#include <netinet/in.h>
#include <linux/if_ether.h>
#include <unistd.h>
#include <sys/time.h>

//#define	sock_type	int
typedef	int	sock_type;
#endif


sock_type	open_socket(char *device, double to_s);
void	close_socket(sock_type sock);
void	set_blocking(sock_type sock, int blocking);
void	set_promiscuous_mode(sock_type sock, char *device, int promiscuous_mode);
int	send_to_socket(sock_type sock, char *device, char *buffer, int buffer_len);
int	recv_from_socket(sock_type sock, char *device, char *buffer, int buffer_len, struct timeval *p_tv);

void	show_packet(char *packet, int packet_len, int is_send);
int	hex_char_to_binary(char c);

void	interrupt_handler(int i);

#endif

