##	Copyright (c) 2004 The Regents of the University of California. All Rights
##	Reserved. Permission to use, copy, modify, and distribute this  software
##	and its documentation for educational, research and non-profit purposes,
##	without fee, and without a written agreement is hereby granted, provided
##	that the above copyright notice, this paragraph and the following two
##	paragraphs appear in all copies. This software program and documentation
##	are copyrighted  by The Regents of the University of California ("The
##	University of California").
##
##	THE SOFTWARE PROGRAM AND DOCUMENTATION ARE SUPPLIED "AS IS," WITHOUT ANY
##	ACCOMPANYING SERVICES FROM THE UNIVERSITY OF CALFORNIA. FURTHERMORE, THE
##	UNIVERSITY OF CALIFORNIA DOES NOT WARRANT THAT THE OPERATION OF THE
##	PROGRAM  WILL BE UNINTERRUPTED OR ERROR-FREE. THE END-USER UNDERSTANDS
##	THAT THE PROGRAM  WAS DEVELOPED FOR RESEARCH PURPOSES AND IS ADVISED NOT
##	TO RELY EXCLUSIVELY  ON THE PROGRAM FOR ANY REASON.
##
##	IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
##	DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING
##	LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
##	DOCUMENTATION,  EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF
##	THE POSSIBILITY OF SUCH DAMAGES. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY
##	DISCLAIMS ANY  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
##	WARRANTIES OF  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE
##	SOFTWARE PROVIDED  HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
##	CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
##	ENHANCEMENTS, OR  MODIFICATIONS.

from	Tkinter import *
import	my_tkDialog
import	tkMessageBox

cfg = 'calib.cfg'

def	read(parent):
	try:
		for l in open(cfg).readlines(): exec l

		parent.VREF_ADC = VREF_ADC
		parent.VREF_DAC = VREF_DAC
		parent.RC_ADC = RC_ADC

		parent.V0_DAC = V0_DAC
		parent.V0_ADC = V0_ADC
		parent.C0_ADC = C0_ADC
		parent.R0_VREG = R0_VREG
	except:
		parent.VREF_ADC = 5.0
		parent.VREF_DAC = 5.0
		parent.RC_ADC = 10e3

		parent.V0_DAC = 0.
		parent.V0_ADC = 0.
		parent.C0_ADC = 0.
		parent.R0_VREG = 0.

		write(parent)

	if parent.demo_mode != 1:
		parent.util.set_vref_adc(parent.VREF_ADC)
		parent.util.set_vref_dac(parent.VREF_DAC)
		parent.util.set_rc_adc(parent.RC_ADC)
		
		parent.util.set_voffset_dac(parent.V0_DAC)
		parent.util.set_voffset_adc(parent.V0_ADC)
		parent.util.set_coffset_adc(parent.C0_ADC)
		parent.util.set_r_vreg(parent.R0_VREG)

		parent.VREF_ADC = parent.util.get_vref_adc()
		parent.VREF_DAC = parent.util.get_vref_dac()
		parent.RC_ADC = parent.util.get_rc_adc()
		
		parent.V0_DAC = parent.util.get_voffset_dac()
		parent.V0_ADC = parent.util.get_voffset_adc()
		parent.C0_ADC = parent.util.get_coffset_adc()
		parent.R0_VREG = parent.util.get_r_vreg()

		
def	write(parent):
	f = open(cfg, 'w')
	print >> f, 'VREF_ADC =', parent.VREF_ADC
	print >> f, 'VREF_DAC =', parent.VREF_DAC
	print >> f, 'RC_ADC =', parent.RC_ADC
	
	print >> f, 'V0_DAC =', parent.V0_DAC
	print >> f, 'V0_ADC =', parent.V0_ADC
	print >> f, 'C0_ADC =', parent.C0_ADC
	print >> f, 'R0_VREG =', parent.R0_VREG
	f.close()
	
	
class	clb_dlg(my_tkDialog.Dialog):
	def	__init__(self, parent):
		self.init = 0
		my_tkDialog.Dialog.__init__(self, parent, title = 'Calibration', wait_for_close = 1)


	def	body(self, master):
		Label(master, text = 'V_out:').grid(row = 0, sticky = W)

		Label(master, text = 'V_out_DAC:').grid(row = 1, sticky = W)

		Label(master, text = '').grid(row = 2, sticky = W)

		Label(master, text = 'VREF_ADC:').grid(row = 3, sticky = W)

		Label(master, text = 'VREF_DAC:').grid(row = 4, sticky = W)

		Label(master, text = 'RC_ADC:').grid(row = 5, sticky = W)

		Label(master, text = 'V0_DAC:').grid(row = 6, sticky = W)

		Label(master, text = 'V0_ADC:').grid(row = 7, sticky = W)

		Label(master, text = 'C0_ADC:').grid(row = 8, sticky = W)

		Label(master, text = 'R0_VREG:').grid(row = 9, sticky = W)

		self.e1 = Entry(master)
		self.e2 = Entry(master)
		
		self.e3 = Entry(master)
		self.e4 = Entry(master)
		self.e5 = Entry(master)
		self.e6 = Entry(master)
		self.e7 = Entry(master)
		self.e8 = Entry(master)
		self.e9 = Entry(master)

		self.e1.grid(row = 0, column = 1)
		self.e2.grid(row = 1, column = 1)

		self.e3.grid(row = 3, column = 1)
		self.e4.grid(row = 4, column = 1)
		
		self.e5.grid(row = 5, column = 1)
		self.e6.grid(row = 6, column = 1)
		self.e7.grid(row = 7, column = 1)
		self.e8.grid(row = 8, column = 1)
		self.e9.grid(row = 9, column = 1)


		self.VREF_ADC = self.parent.VREF_ADC
		self.VREF_DAC = self.parent.VREF_DAC
		self.RC_ADC = self.parent.RC_ADC
		
		self.V0_DAC = self.parent.V0_DAC
		self.V0_ADC = self.parent.V0_ADC
		self.C0_ADC = self.parent.C0_ADC
		self.R0_VREG = self.parent.R0_VREG
			

		self.e3.insert(0, str(self.VREF_ADC))
		self.e4.insert(0, str(self.VREF_DAC))
		self.e5.insert(0, str(self.RC_ADC))

		self.e6.insert(0, str(self.V0_DAC))
		self.e7.insert(0, str(self.V0_ADC))
		self.e8.insert(0, str(self.C0_ADC))
		self.e9.insert(0, str(self.R0_VREG))

		self.e2.config(state = DISABLED)


	def	validate(self):
		v = None
		v_str = self.e1.get()
		if v_str.strip() != '':
			try:
				v = float(v_str)
			except:
				tkMessageBox.showwarning('Bad input', 'Illegal numerical values')
				return 0
			if v <= 0 or v > 5:
				tkMessageBox.showwarning('Bad input', 'v <= 0 || v > 5')
				return 0
		try:
			self.VREF_ADC = float(self.e3.get())
			self.VREF_DAC = float(self.e4.get())
			self.RC_ADC = float(self.e5.get())
			
			self.V0_DAC = float(self.e6.get())
			self.V0_ADC = float(self.e7.get())
			self.C0_ADC = float(self.e8.get())
			self.R0_VREG = float(self.e9.get())
		except:
			tkMessageBox.showwarning('Bad input', 'Illegal numerical values')
			return 0
		
		if self.VREF_ADC <= 0 or self.VREF_ADC > 5:
			tkMessageBox.showwarning('Bad input', 'VREF_ADC <= 0 || VREF_ADC > 5')
			return 0

		if self.VREF_DAC <= 0 or self.VREF_DAC > 5:
			tkMessageBox.showwarning('Bad input', 'VREF_DAC <= 0 || VREF_DAC > 5')
			return 0

		if self.RC_ADC <= 0:
			tkMessageBox.showwarning('Bad input', 'RC_ADC <= 0')
			return 0

		if self.parent.demo_mode != 1:
			self.parent.util.set_vref_adc(self.VREF_ADC)
			self.parent.util.set_vref_dac(self.VREF_DAC)
			self.parent.util.set_rc_adc(self.RC_ADC)

			self.parent.util.set_voffset_dac(self.V0_DAC)
			self.parent.util.set_voffset_adc(self.V0_ADC)
			self.parent.util.set_coffset_adc(self.C0_ADC)
			self.parent.util.set_r_vreg(self.R0_VREG)

			self.VREF_ADC = self.parent.util.get_vref_adc()
			self.VREF_DAC = self.parent.util.get_vref_dac()
			self.RC_ADC = self.parent.util.get_rc_adc()

			self.V0_DAC = self.parent.util.get_voffset_dac()
			self.V0_ADC = self.parent.util.get_voffset_adc()
			self.C0_ADC = self.parent.util.get_coffset_adc()
			self.R0_VREG = self.parent.util.get_r_vreg()

			self.e3.delete(0, END)
			self.e3.insert(0, str(self.VREF_ADC))
			self.e4.delete(0, END)
			self.e4.insert(0, str(self.VREF_DAC))
			self.e5.delete(0, END)
			self.e5.insert(0, str(self.RC_ADC))

			self.e6.delete(0, END)
			self.e6.insert(0, str(self.V0_DAC))
			self.e7.delete(0, END)
			self.e7.insert(0, str(self.V0_ADC))
			self.e8.delete(0, END)
			self.e8.insert(0, str(self.C0_ADC))
			self.e9.delete(0, END)
			self.e9.insert(0, str(self.R0_VREG))

			if v != None:
				if self.init == 0:
					self.parent.util.initEmulation()
					self.init = 1
				v = self.parent.util.test_emu_voltage(v)

				self.e2.config(state = NORMAL)				
				self.e2.delete(0, END)
				self.e2.insert(0, str(v))
				self.e2.config(state = DISABLED)

		self.parent.VREF_ADC = self.VREF_ADC
		self.parent.VREF_DAC = self.VREF_DAC
		self.parent.RC_ADC = self.RC_ADC
				
		self.parent.V0_DAC = self.V0_DAC
		self.parent.V0_ADC = self.V0_ADC
		self.parent.C0_ADC = self.C0_ADC
		self.parent.R0_VREG = self.R0_VREG

		self.result = 1
		return self.result



if	__name__ == '__main__':
	global	root

	def	test():
		d = clb_dlg(root)
		print d.result        	

	root = Tk()
	Button(root, text = 'Test', command = test).pack()
	root.mainloop()
