##	Copyright (c) 2004 The Regents of the University of California. All Rights
##	Reserved. Permission to use, copy, modify, and distribute this  software
##	and its documentation for educational, research and non-profit purposes,
##	without fee, and without a written agreement is hereby granted, provided
##	that the above copyright notice, this paragraph and the following two
##	paragraphs appear in all copies. This software program and documentation
##	are copyrighted  by The Regents of the University of California ("The
##	University of California").
##
##	THE SOFTWARE PROGRAM AND DOCUMENTATION ARE SUPPLIED "AS IS," WITHOUT ANY
##	ACCOMPANYING SERVICES FROM THE UNIVERSITY OF CALFORNIA. FURTHERMORE, THE
##	UNIVERSITY OF CALIFORNIA DOES NOT WARRANT THAT THE OPERATION OF THE
##	PROGRAM  WILL BE UNINTERRUPTED OR ERROR-FREE. THE END-USER UNDERSTANDS
##	THAT THE PROGRAM  WAS DEVELOPED FOR RESEARCH PURPOSES AND IS ADVISED NOT
##	TO RELY EXCLUSIVELY  ON THE PROGRAM FOR ANY REASON.
##
##	IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
##	DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING
##	LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
##	DOCUMENTATION,  EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF
##	THE POSSIBILITY OF SUCH DAMAGES. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY
##	DISCLAIMS ANY  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
##	WARRANTIES OF  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE
##	SOFTWARE PROVIDED  HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
##	CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
##	ENHANCEMENTS, OR  MODIFICATIONS.

from	Tkinter import *
import	my_tkDialog
import	tkMessageBox

cfg = 'flag.cfg'

def	read(parent):
	try:
		for l in open(cfg).readlines(): exec l

		parent.PC_debug1 = PC1
		parent.PC_debug2 = PC2
		parent.B_debug1 = B1
		parent.B_debug2 = B2
	except:
		parent.PC_debug1 = 0
		parent.PC_debug2 = 0
		parent.B_debug1 = 0
		parent.B_debug2 = 0

		write(parent)
		
	if parent.demo_mode != 1:
		parent.util.set_debug_flag1(parent.PC_debug1)
		parent.util.set_debug_flag2(parent.PC_debug2)
		parent.util.set_B_debug_flag1(parent.B_debug1)
		parent.util.set_B_debug_flag2(parent.B_debug2)


def	write(parent):
	f = open(cfg, 'w')
	print >> f, 'PC1 =', parent.PC_debug1
	print >> f, 'PC2 =', parent.PC_debug2
	print >> f, 'B1 =', parent.B_debug1
	print >> f, 'B2 =', parent.B_debug2
	f.close()


class	dbg_dlg(my_tkDialog.Dialog):
	def	__init__(self, parent):
		self.PC1 = IntVar()
		self.PC1.set(parent.PC_debug1)

		self.PC2 = IntVar()
		self.PC2.set(parent.PC_debug2)

		self.B1 = IntVar()
		self.B1.set(parent.B_debug1)

		self.B2 = IntVar()
		self.B2.set(parent.B_debug2)

		my_tkDialog.Dialog.__init__(self, parent, title = 'Debug Flags', wait_for_close = 1)


	def	body(self, master):
		Label(master, text = 'PC:').grid(row = 0, sticky = W)
		Label(master, text = 'B#:').grid(row = 1, sticky = W)

		self.cb1 = Checkbutton(master, text= 'PC1', variable = self.PC1, onvalue = 1, offvalue = 0)
		self.cb2 = Checkbutton(master, text= 'PC2', variable = self.PC2, onvalue = 1, offvalue = 0)
		self.cb3 = Checkbutton(master, text= 'B#1', variable = self.B1, onvalue = 1, offvalue = 0)
		self.cb4 = Checkbutton(master, text= 'B#2', variable = self.B2, onvalue = 1, offvalue = 0)

		self.cb1.grid(row = 0, column = 1)
		self.cb2.grid(row = 0, column = 2)
		self.cb3.grid(row = 1, column = 1)
		self.cb4.grid(row = 1, column = 2)


	def	apply(self):
		if self.parent.demo_mode != 1:
			self.parent.util.set_debug_flag1(self.PC1.get())
			self.parent.util.set_debug_flag2(self.PC2.get())
			self.parent.util.set_B_debug_flag1(self.B1.get())
			self.parent.util.set_B_debug_flag2(self.B2.get())
	
		self.parent.PC_debug1 = self.PC1.get()
		self.parent.PC_debug2 = self.PC2.get()
		self.parent.B_debug1 = self.B1.get()
		self.parent.B_debug2 = self.B2.get()

		return self.result



if	__name__ == '__main__':
	global	root

	def	test():
		d = dbg_dlg(root, 1, 1, 0, 1)
		print d.result        	

	root = Tk()
	Button(root, text = 'Test', command = test).pack()
	root.mainloop()
