##	Copyright (c) 2004 The Regents of the University of California. All Rights
##	Reserved. Permission to use, copy, modify, and distribute this  software
##	and its documentation for educational, research and non-profit purposes,
##	without fee, and without a written agreement is hereby granted, provided
##	that the above copyright notice, this paragraph and the following two
##	paragraphs appear in all copies. This software program and documentation
##	are copyrighted  by The Regents of the University of California ("The
##	University of California").
##
##	THE SOFTWARE PROGRAM AND DOCUMENTATION ARE SUPPLIED "AS IS," WITHOUT ANY
##	ACCOMPANYING SERVICES FROM THE UNIVERSITY OF CALFORNIA. FURTHERMORE, THE
##	UNIVERSITY OF CALIFORNIA DOES NOT WARRANT THAT THE OPERATION OF THE
##	PROGRAM  WILL BE UNINTERRUPTED OR ERROR-FREE. THE END-USER UNDERSTANDS
##	THAT THE PROGRAM  WAS DEVELOPED FOR RESEARCH PURPOSES AND IS ADVISED NOT
##	TO RELY EXCLUSIVELY  ON THE PROGRAM FOR ANY REASON.
##
##	IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
##	DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING
##	LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
##	DOCUMENTATION,  EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF
##	THE POSSIBILITY OF SUCH DAMAGES. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY
##	DISCLAIMS ANY  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
##	WARRANTIES OF  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE
##	SOFTWARE PROVIDED  HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
##	CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
##	ENHANCEMENTS, OR  MODIFICATIONS.

from	Tkinter import *
import	my_tkDialog
import	tkMessageBox

cfg = 'emu.cfg'

def	read(parent):
	try:
		for l in open(cfg).readlines(): exec l

		parent.emu_interval = interval
		parent.emu_timer_tick = timer_tick
		parent.emu_time = duration
	except:
		parent.emu_interval = 0.15
		parent.emu_timer_tick = 15
		parent.emu_time = 600.

		write(parent)

	if parent.demo_mode != 1:
		parent.util.set_sim_interval(parent.emu_interval)
		parent.util.set_max_tick(parent.emu_timer_tick)

		parent.util.initParameter()
		
		parent.emu_interval = parent.util.get_sim_interval()
		parent.emu_timer_tick = parent.util.get_max_tick()
		

def	write(parent):
	f = open(cfg, 'w')
	print >> f, 'interval =', parent.emu_interval
	print >> f, 'timer_tick =', parent.emu_timer_tick
	print >> f, 'duration =', parent.emu_time
	f.close()


class	emu_dlg(my_tkDialog.Dialog):
	def	__init__(self, parent):
		self.interval = parent.emu_interval
		self.tick = parent.emu_timer_tick
		self.duration = parent.emu_time
		my_tkDialog.Dialog.__init__(self, parent, title = 'Emulation Parameters')


	def	body(self, master):
		Label(master, text = 'Interval:').grid(row = 0, sticky = W)
		Label(master, text = 'Timer tick:').grid(row = 1, sticky = W)
		Label(master, text = 'Duration:').grid(row = 2, sticky = W)

		self.e1 = Entry(master)
		self.e2 = Entry(master)
		self.e3 = Entry(master)

		self.e1.grid(row = 0, column = 1)
		self.e2.grid(row = 1, column = 1)
		self.e3.grid(row = 2, column = 1)

		self.e1.insert(0, str(self.interval))
		self.e2.insert(0, str(self.tick))
		self.e3.insert(0, str(self.duration))


	def	validate(self):
		try:
			interval = float(self.e1.get())
			tick = int(self.e2.get())
			duration = float(self.e3.get())
		except:
			tkMessageBox.showwarning('Bad input', 'Illegal numerical values')
			return 0
		if interval <= 0:
			tkMessageBox.showwarning('Bad input', 'Interval <= 0')
			return 0
		if tick <= 0:
			tkMessageBox.showwarning('Bad input', 'Timer tick <= 0')
			return 0
		if duration <= 0:
			tkMessageBox.showwarning('Bad input', 'Duration <= 0')
			return 0
		
		self.interval = interval
		self.tick = tick
		self.duration = duration
		return 1


	def	apply(self):
		if self.parent.demo_mode != 1:
			self.parent.util.set_sim_interval(self.interval)
			self.parent.util.set_max_tick(self.tick)

			self.parent.util.initParameter()
			
			self.interval = self.parent.util.get_sim_interval()
			self.tick= self.parent.util.get_max_tick()

		self.e1.delete(0, END)			
		self.e1.insert(0, str(self.interval))
		self.e2.delete(0, END)
		self.e2.insert(0, str(self.tick))

		self.parent.emu_interval = self.interval
		self.parent.emu_timer_tick = self.tick
		self.parent.emu_time = self.duration

		return self.result



if	__name__ == '__main__':
	global	root

	def	test():
		d = emu_dlg(root, 0.3, 30, 600)
		print d.result        	

	root = Tk()
	Button(root, text = 'Test', command = test).pack()
	root.mainloop()
