#!/usr/bin/python

import os, sys

def	visit(keywords, top, names):
	if 'RCS' in names:
		names.remove('RCS')
	for f in [n for n in names]:
#		print f
		hit = 0
		for word in keywords:
			if f.endswith(word):
				hit = 1
				break
		if not hit:
#			print f, ' is not an asc file'
			continue
		fullname = os.path.join(top, f)
		if os.path.isfile(fullname):
			s = ascCheck(fullname)
			if s != 0:
				ascRewrite(fullname, s)
#			else:
#				print 'File ', fullname, ' OK'
#		else:
#			print 'File ', fullname, ' is not a file'
	return names

def	ascCheck(filename):
	f = open(filename, 'rb')
	s = f.read()
	f.close()
	linesep = os.linesep
	lines = s.split(linesep)
	if linesep == '\r\n':
		for line in lines:
			if line.count('\r') or line.count('\n'):
				return s
	if linesep == '\r':
		for line in lines:
			if line.count('\n'):
				return s
	else:
		for line in lines:
			if line.count('\r'):
				return s
	return 0

def	ascRewrite(filename, s):
	lines = []
	line_start = 0
	i = 0
	while i < len(s):
		if s[i] == '\r':
			lines.append(s[line_start : i])
			i = i + 1
			if i == len(s):
				line_start = i
				break
			if s[i] == '\n':
				line_start = i + 1
			else:
				line_start = i
			i = i + 1
		elif s[i] == '\n':
			lines.append(s[line_start : i])
			i = i + 1
			line_start = i
		else:
			i = i + 1
	if line_start != len(s):
		lines.append(s[line_start:])

	f = open(filename, 'wb')
	linesep = os.linesep
	for line in lines:
		f.write(line + linesep)
	f.close()
	print 'Rewritten file: ', filename

if __name__ == '__main__':
	if len(sys.argv) != 2:
		print 'Usage: fixasc.py directory'
		sys.exit(1)
	if os.path.isdir(sys.argv[1]):
		top = sys.argv[1]
	else:
		print 'Directory ', sys.argv[1], ' does not exist'
		sys.exit(1)

##	current_path = os.path.abspath('.')
##	(base, top_name) = os.path.split(os.path.abspath(top))
##	os.chdir(base)
##	if top_name.endswith(os.sep):
##		top_name = top_name[:len(top_name) - 1]

	asc_file_ext = ('.c', '.h', 'Makefile', '.py', '.sh', '.bat', '.BAT', '.txt', '.TXT', '.out', '.f', '.mak', '.MAK')
	os.path.walk(top, visit, asc_file_ext)
#	os.chdir(current_path)
