##	Copyright (c) 2004 The Regents of the University of California. All Rights
##	Reserved. Permission to use, copy, modify, and distribute this  software
##	and its documentation for educational, research and non-profit purposes,
##	without fee, and without a written agreement is hereby granted, provided
##	that the above copyright notice, this paragraph and the following two
##	paragraphs appear in all copies. This software program and documentation
##	are copyrighted  by The Regents of the University of California ("The
##	University of California").
##
##	THE SOFTWARE PROGRAM AND DOCUMENTATION ARE SUPPLIED "AS IS," WITHOUT ANY
##	ACCOMPANYING SERVICES FROM THE UNIVERSITY OF CALFORNIA. FURTHERMORE, THE
##	UNIVERSITY OF CALIFORNIA DOES NOT WARRANT THAT THE OPERATION OF THE
##	PROGRAM  WILL BE UNINTERRUPTED OR ERROR-FREE. THE END-USER UNDERSTANDS
##	THAT THE PROGRAM  WAS DEVELOPED FOR RESEARCH PURPOSES AND IS ADVISED NOT
##	TO RELY EXCLUSIVELY  ON THE PROGRAM FOR ANY REASON.
##
##	IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
##	DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING
##	LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
##	DOCUMENTATION,  EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF
##	THE POSSIBILITY OF SUCH DAMAGES. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY
##	DISCLAIMS ANY  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
##	WARRANTIES OF  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE
##	SOFTWARE PROVIDED  HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
##	CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
##	ENHANCEMENTS, OR  MODIFICATIONS.

from	Tkinter import *

class	BusyManager:
	def __init__(self, widget):
		self.toplevel = widget.winfo_toplevel()
		self.saved_cursors = {}
		self.saved_states = {}

	def busy(self, widget = None, active_widgets = []):

		if widget is None:
			w = self.toplevel # myself
		else:
			w = widget
		if w in active_widgets:
			#print widget, active_widgets
			return 0

		r = 1
		for child in w.children.values():
			if self.busy(child, active_widgets) == 0:
				r = 0
		if r == 0:
			return 0
		
		if not self.saved_cursors.has_key(str(w)):
			try:
				cursor = w.cget('cursor')
				if cursor != 'watch':
					self.saved_cursors[str(w)] = (w, cursor)
					w.config(cursor = 'watch')
			except TclError:
				pass

		if not self.saved_states.has_key(str(w)):
			try:
				state = w.cget('state')
				if state != DISABLED:
					self.saved_states[str(w)] = (w, state)
					w.config(state = DISABLED)
			except TclError:
				pass

		return 1
	

	def notbusy(self):
		for w, cursor in self.saved_cursors.values():
			try:
				w.config(cursor = cursor)
			except TclError:
				pass

		for w, state in self.saved_states.values():
			try:
				w.config(state = state)
			except TclError:
				pass

		self.saved_cursors = {}
		self.saved_states = {}

#global	b2

if __name__ == '__main__':
	def	test(event = None):
		nb = [b2]
		manager.busy(root, nb)

	root = Tk()

	Label(root, text="a label").pack()

	Button(root, text="a button").pack()

	Entry(root, text="an entry").pack()

	scrollbar = Scrollbar(root, orient=VERTICAL)
	
	w = Listbox(root, height = 1, selectmode=SINGLE, yscrollcommand=scrollbar.set)
	
	for i in range(10):
		w.insert(i, "item %d" % (i+1))
	#w.pack()
	w.pack(side=LEFT)

	scrollbar.config(command=w.yview)
	scrollbar.pack(side=LEFT)
	
	w = Text(root, width=20, height=10)
	w.insert(1.0, "a text widget")
	w.pack(side=TOP)

	manager = BusyManager(root)

	b1 = Button(root, text='busy!', command = test)
	b1.pack()

	b2 = Button(root, text='not busy!', command = manager.notbusy)
	#print b2
	b2.pack()

	root.mainloop()
