##	Copyright (c) 2004 The Regents of the University of California. All Rights
##	Reserved. Permission to use, copy, modify, and distribute this  software
##	and its documentation for educational, research and non-profit purposes,
##	without fee, and without a written agreement is hereby granted, provided
##	that the above copyright notice, this paragraph and the following two
##	paragraphs appear in all copies. This software program and documentation
##	are copyrighted  by The Regents of the University of California ("The
##	University of California").
##
##	THE SOFTWARE PROGRAM AND DOCUMENTATION ARE SUPPLIED "AS IS," WITHOUT ANY
##	ACCOMPANYING SERVICES FROM THE UNIVERSITY OF CALFORNIA. FURTHERMORE, THE
##	UNIVERSITY OF CALIFORNIA DOES NOT WARRANT THAT THE OPERATION OF THE
##	PROGRAM  WILL BE UNINTERRUPTED OR ERROR-FREE. THE END-USER UNDERSTANDS
##	THAT THE PROGRAM  WAS DEVELOPED FOR RESEARCH PURPOSES AND IS ADVISED NOT
##	TO RELY EXCLUSIVELY  ON THE PROGRAM FOR ANY REASON.
##
##	IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
##	DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING
##	LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
##	DOCUMENTATION,  EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF
##	THE POSSIBILITY OF SUCH DAMAGES. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY
##	DISCLAIMS ANY  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
##	WARRANTIES OF  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE
##	SOFTWARE PROVIDED  HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
##	CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
##	ENHANCEMENTS, OR  MODIFICATIONS.

from	Tkinter import *
import	tkSimpleDialog

class Dialog(tkSimpleDialog.Dialog):
	def __init__(self, parent, title = None, has_cancel = 1, has_apply = 1, wait_for_close = 1, focus_on_OK = 0):
		self.has_cancel = has_cancel
		self.has_apply = has_apply
		self.wait_for_close = wait_for_close
		self.focus_on_OK = focus_on_OK
		
		Toplevel.__init__(self, parent)
		self.transient(parent)

		if title:
			self.title(title)

		self.parent = parent

		self.result = None

		body = Frame(self)
		self.initial_focus = self.body(body)
		body.pack(padx = 5, pady = 5)

		self.buttonbox()

		if self.wait_for_close: 
			self.grab_set()

		if not self.initial_focus:
			self.initial_focus = self

		self.protocol('WM_DELETE_WINDOW', self.cancel)

		if self.parent is not None:
			self.geometry('+%d+%d' % (parent.winfo_rootx() + 50,
									  parent.winfo_rooty() + 50))

		self.initial_focus.focus_set()

		if self.wait_for_close: 
			self.wait_window(self)

	
	def buttonbox(self):
		box = Frame(self)

		self.ok_button = Button(box, text = 'OK', width = 10, command = self.ok, default = ACTIVE)
		self.ok_button.pack(side = LEFT, padx = 5, pady = 5)
		
		if self.has_cancel:
			self.cancel_button = Button(box, text = 'Cancel', width = 10, command = self.cancel)
			self.cancel_button.pack(side = LEFT, padx = 5, pady = 5)

		if self.has_apply:
			self.apply_button = Button(box, text='Apply', width = 10, command = self.test, default = ACTIVE)
			self.apply_button.pack(side = LEFT, padx = 5, pady = 5)

		if self.focus_on_OK or not self.has_apply:
			self.bind('<Return>', self.ok)
		else:
			self.bind('<Return>', self.test)
			
		self.bind('<Escape>', self.cancel)

		box.pack()


	def test(self, event=None):
		if not self.validate():
			self.initial_focus.focus_set() # put focus back
			return

		self.update_idletasks()

		self.apply()
