##	Copyright (c) 2004 The Regents of the University of California. All Rights
##	Reserved. Permission to use, copy, modify, and distribute this  software
##	and its documentation for educational, research and non-profit purposes,
##	without fee, and without a written agreement is hereby granted, provided
##	that the above copyright notice, this paragraph and the following two
##	paragraphs appear in all copies. This software program and documentation
##	are copyrighted  by The Regents of the University of California ("The
##	University of California").
##
##	THE SOFTWARE PROGRAM AND DOCUMENTATION ARE SUPPLIED "AS IS," WITHOUT ANY
##	ACCOMPANYING SERVICES FROM THE UNIVERSITY OF CALFORNIA. FURTHERMORE, THE
##	UNIVERSITY OF CALIFORNIA DOES NOT WARRANT THAT THE OPERATION OF THE
##	PROGRAM  WILL BE UNINTERRUPTED OR ERROR-FREE. THE END-USER UNDERSTANDS
##	THAT THE PROGRAM  WAS DEVELOPED FOR RESEARCH PURPOSES AND IS ADVISED NOT
##	TO RELY EXCLUSIVELY  ON THE PROGRAM FOR ANY REASON.
##
##	IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
##	DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING
##	LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
##	DOCUMENTATION,  EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF
##	THE POSSIBILITY OF SUCH DAMAGES. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY
##	DISCLAIMS ANY  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
##	WARRANTIES OF  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE
##	SOFTWARE PROVIDED  HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
##	CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
##	ENHANCEMENTS, OR  MODIFICATIONS.

from	Tkinter import *
import	my_tkDialog
import	tkMessageBox

cfg = 'net.cfg'

def	read(parent):
	if parent.demo_mode != 1:
		try:
			for l in open(cfg).readlines(): exec l
			
			parent.interface = interface
			parent.blocking = blocking
		except:
			import sys
			if sys.platform == 'win32':
				import os
				os.system('iflist > net.tmp')
				interface = open('net.tmp').readlines()[0]
			else:
				interface = 'eth0'
			parent.interface = interface.strip()
			parent.blocking = 1
			
			write(parent)

		parent.util.set_interface(parent.interface)
		parent.util.set_blocking(parent.blocking)
	else:
			parent.interface = 'None'
			parent.blocking = 0


def	write(parent):
	f = open(cfg, 'w')
	print >> f, 'interface =', '\"' + parent.interface + '\"'
	print >> f, 'blocking =', parent.blocking
	f.close()
		

class	net_dlg(my_tkDialog.Dialog):
	def	__init__(self, parent):
		self.interface = parent.interface
		self.blocking = IntVar()
		self.blocking.set(parent.blocking)
		my_tkDialog.Dialog.__init__(self, parent, title = 'Network')


	def	body(self, master):
		Label(master, text = 'Interface:').grid(row = 0, sticky = W)
		Label(master, text = 'Recv mode:').grid(row = 1, sticky = W)

		self.e1 = Entry(master)
		self.cb1 = Checkbutton(master, text= 'blocking', variable = self.blocking, onvalue = 1, offvalue = 0)
		
		self.e1.grid(row = 0, column = 1)
		self.cb1.grid(row = 1, column = 1)

		self.e1.insert(0, self.interface)

	def	validate(self):
		if self.parent.demo_mode != 1:
			interface = self.e1.get()
			blocking = self.blocking.get()
			
			self.parent.util.set_interface(interface)
			self.parent.util.set_blocking(blocking)

			r = self.parent.util.start_network()
			if r == None:
				tkMessageBox.showwarning('Network error', 'Cannot start network')
				return 0
			else:
				return 1
		else:
			return 1
		

	def	apply(self):
		self.interface = self.e1.get()
		
		self.parent.interface = self.interface
		self.parent.blocking = self.blocking.get()
		
		return 1



if	__name__ == '__main__':
	global	root

	def	test():
		d = net_dlg(root, 'eth0', 1)
		print d.result        	

	root = Tk()
	Button(root, text = 'Test', command = test).pack()
	root.mainloop()
