##	Copyright (c) 2004 The Regents of the University of California. All Rights
##	Reserved. Permission to use, copy, modify, and distribute this  software
##	and its documentation for educational, research and non-profit purposes,
##	without fee, and without a written agreement is hereby granted, provided
##	that the above copyright notice, this paragraph and the following two
##	paragraphs appear in all copies. This software program and documentation
##	are copyrighted  by The Regents of the University of California ("The
##	University of California").
##
##	THE SOFTWARE PROGRAM AND DOCUMENTATION ARE SUPPLIED "AS IS," WITHOUT ANY
##	ACCOMPANYING SERVICES FROM THE UNIVERSITY OF CALFORNIA. FURTHERMORE, THE
##	UNIVERSITY OF CALIFORNIA DOES NOT WARRANT THAT THE OPERATION OF THE
##	PROGRAM  WILL BE UNINTERRUPTED OR ERROR-FREE. THE END-USER UNDERSTANDS
##	THAT THE PROGRAM  WAS DEVELOPED FOR RESEARCH PURPOSES AND IS ADVISED NOT
##	TO RELY EXCLUSIVELY  ON THE PROGRAM FOR ANY REASON.
##
##	IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
##	DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING
##	LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
##	DOCUMENTATION,  EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF
##	THE POSSIBILITY OF SUCH DAMAGES. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY
##	DISCLAIMS ANY  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
##	WARRANTIES OF  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE
##	SOFTWARE PROVIDED  HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
##	CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
##	ENHANCEMENTS, OR  MODIFICATIONS.

from	Tkinter import *
import	my_tkDialog
import	tkMessageBox
import	tkColorChooser

cfg = 'paint.cfg'

def	read(parent):
	try:
		for l in open(cfg).readlines(): exec l
		
		parent.pro_color = pro_color
		parent.emu_color = emu_color
		parent.sim_color = sim_color
		parent.pos_color = pos_color
		
		parent.pro_width = pro_width
		parent.emu_width = emu_width
		parent.sim_width = sim_width
		parent.pos_width = pos_width

	except:
		parent.pro_color = '#ff0000'
		parent.emu_color = '#0000ff'
		parent.sim_color = '#008000'
		parent.pos_color = '#800080'

		parent.pro_width = 1
		parent.emu_width = 1
		parent.sim_width = 1
		parent.pos_width = 1

		write(parent)


def	write(parent):
	f = open(cfg, 'w')
	print >> f, 'pro_color =', '\"' + parent.pro_color + '\"'
	print >> f, 'emu_color =', '\"' + parent.emu_color + '\"'
	print >> f, 'sim_color =', '\"' + parent.sim_color + '\"'
	print >> f, 'pos_color =', '\"' + parent.pos_color + '\"'

	print >> f, 'pro_width =', parent.pro_width
	print >> f, 'emu_width =', parent.emu_width
	print >> f, 'sim_width =', parent.sim_width
	print >> f, 'pos_width =', parent.pos_width

	f.close()


class	pnt_dlg(my_tkDialog.Dialog):
	def	__init__(self, parent):
		self.pro_color = parent.pro_color
		self.emu_color = parent.emu_color
		self.sim_color = parent.sim_color
		self.pos_color = parent.pos_color
		
		self.pro_width = IntVar()
		self.pro_width.set(parent.pro_width)
		
		self.emu_width = IntVar()
		self.emu_width.set(parent.emu_width)

		self.sim_width = IntVar()
		self.sim_width.set(parent.sim_width)
		
		self.pos_width = IntVar()
		self.pos_width.set(parent.pos_width)

		my_tkDialog.Dialog.__init__(self, parent, title = 'Paint', wait_for_close = 0)


	def	body(self, master):
		white = '#ffffff'
		
		Label(master, text = 'Profiling:').grid(row = 0, sticky = W)
		Label(master, text = 'Emulation:').grid(row = 1, sticky = W)
		Label(master, text = 'Simlation:').grid(row = 2, sticky = W)
		Label(master, text = 'Post-profiling:').grid(row = 3, sticky = W)

		self.b1 = Button(master, text = 'Color', bg = self.pro_color, activeforeground = self.pro_color, fg = white, command = self.setProColor)
		self.b2 = Button(master, text = 'Color', bg = self.emu_color, activeforeground = self.emu_color, fg = white, command = self.setEmuColor)
		self.b3 = Button(master, text = 'Color', bg = self.sim_color, activeforeground = self.sim_color, fg = white, command = self.setSimColor)
		self.b4 = Button(master, text = 'Color', bg = self.pos_color, activeforeground = self.pos_color, fg = white, command = self.setPosColor)

		Label(master, text = '     Line width:').grid(row = 0, column = 4)
		Label(master, text = '     Line width:').grid(row = 1, column = 4)
		Label(master, text = '     Line width:').grid(row = 2, column = 4)
		Label(master, text = '     Line width:').grid(row = 3, column = 4)

		self.o1 = OptionMenu(master, self.pro_width, 1, 2, 3, 4, 5)
		self.o2 = OptionMenu(master, self.emu_width, 1, 2, 3, 4, 5)
		self.o3 = OptionMenu(master, self.sim_width, 1, 2, 3, 4, 5)
		self.o4 = OptionMenu(master, self.pos_width, 1, 2, 3, 4, 5)

		Label(master, text = '     Clear chart:').grid(row = 0, column = 6)
		Label(master, text = '     Clear chart:').grid(row = 1, column = 6)
		Label(master, text = '     Clear chart:').grid(row = 2, column = 6)
		Label(master, text = '     Clear chart:').grid(row = 3, column = 6)

		self.b5 = Button(master, text = 'Clear', command = self.clearProChart)
		self.b6 = Button(master, text = 'Clear', command = self.clearEmuChart)
		self.b7 = Button(master, text = 'Clear', command = self.clearSimChart)
		self.b8 = Button(master, text = 'Clear', command = self.clearPosChart)

		self.b1.grid(row = 0, column = 2)
		self.b2.grid(row = 1, column = 2)
		self.b3.grid(row = 2, column = 2)
		self.b4.grid(row = 3, column = 2)
		
		self.o1.grid(row = 0, column = 5)
		self.o2.grid(row = 1, column = 5)
		self.o3.grid(row = 2, column = 5)
		self.o4.grid(row = 3, column = 5)

		self.b5.grid(row = 0, column = 7)
		self.b6.grid(row = 1, column = 7)
		self.b7.grid(row = 2, column = 7)
		self.b8.grid(row = 3, column = 7)


	def	apply(self):
		self.parent.setWait()

		color_list = [None] * 4
		color_list[self.parent.pro_curve_index] = self.pro_color
		color_list[self.parent.emu_curve_index] = self.emu_color
		color_list[self.parent.sim_curve_index] = self.sim_color
		color_list[self.parent.pos_curve_index] = self.pos_color
		
		width_list = [None] * 4
		width_list[self.parent.pro_curve_index] = self.pro_width.get()
		width_list[self.parent.emu_curve_index] = self.emu_width.get()
		width_list[self.parent.sim_curve_index] = self.sim_width.get()
		width_list[self.parent.pos_curve_index] = self.pos_width.get()


		self.parent.v_chart.updateColorWidth(color_list, width_list)
		
		self.parent.c_chart.updateColorWidth(color_list, width_list)

		self.parent.clearWait()		

		self.parent.pro_color = self.pro_color
		self.parent.emu_color = self.emu_color
		self.parent.sim_color = self.sim_color
		self.parent.pos_color = self.pos_color
		
		self.parent.pro_width = self.pro_width.get()
		self.parent.emu_width = self.emu_width.get()
		self.parent.sim_width = self.sim_width.get()
		self.parent.pos_width = self.pos_width.get()

		self.update()
						  
		return self.result


	def	setProColor(self):
		rgb, c = tkColorChooser.askcolor(color = self.pro_color)
		if c == None:
			return
		self.pro_color = c
		self.b1.config(bg = self.pro_color, activeforeground = self.pro_color)


	def	setEmuColor(self):
		rgb, c = tkColorChooser.askcolor(color = self.emu_color)
		if c == None:
			return
		self.emu_color = c
		self.b2.config(bg = self.emu_color, activeforeground = self.emu_color )


	def	setSimColor(self):
		rgb, c = tkColorChooser.askcolor(color = self.sim_color)
		if c == None:
			return
		self.sim_color = c
		self.b3.config(bg = self.sim_color, activeforeground = self.sim_color)


	def	setPosColor(self):
		rgb, c = tkColorChooser.askcolor(color = self.pos_color)
		if c == None:
			return
		self.pos_color = c
		self.b4.config(bg = self.pos_color, activeforeground = self.pos_color)


	def	clearProChart(self):
		self.parent.setWait()
		
		self.parent.v_chart.clearData(self.parent.pro_curve_index)
		self.parent.c_chart.clearData(self.parent.pro_curve_index)

		self.parent.pro_data_file = ''
		self.parent.pro_trace_file = ''

		self.parent.clearWait()	


	def	clearEmuChart(self):
		self.parent.setWait()
		
		self.parent.v_chart.clearData(self.parent.emu_curve_index)
		self.parent.c_chart.clearData(self.parent.emu_curve_index)

		self.parent.emu_data_file = ''
		self.parent.emu_trace_file = ''

		self.parent.clearWait()	


	def	clearSimChart(self):
		self.parent.setWait()
		
		self.parent.v_chart.clearData(self.parent.sim_curve_index)
		self.parent.c_chart.clearData(self.parent.sim_curve_index)

		self.parent.sim_data_file = ''
		self.parent.sim_trace_file = ''

		self.parent.clearWait()	


	def	clearPosChart(self):
		self.parent.setWait()
		
		self.parent.v_chart.clearData(self.parent.pos_curve_index)
		self.parent.c_chart.clearData(self.parent.pos_curve_index)

		self.parent.pos_data_file = ''

		self.parent.clearWait()	




if	__name__ == '__main__':
	global	root

	def	test():
		d = pnt_dlg(root, 0, 5, 0, 1, 0, 60)
		print d.result        	

	root = Tk()
	Button(root, text = 'Test', command = test).pack()
	root.mainloop()
