##	Copyright (c) 2004 The Regents of the University of California. All Rights
##	Reserved. Permission to use, copy, modify, and distribute this  software
##	and its documentation for educational, research and non-profit purposes,
##	without fee, and without a written agreement is hereby granted, provided
##	that the above copyright notice, this paragraph and the following two
##	paragraphs appear in all copies. This software program and documentation
##	are copyrighted  by The Regents of the University of California ("The
##	University of California").
##
##	THE SOFTWARE PROGRAM AND DOCUMENTATION ARE SUPPLIED "AS IS," WITHOUT ANY
##	ACCOMPANYING SERVICES FROM THE UNIVERSITY OF CALFORNIA. FURTHERMORE, THE
##	UNIVERSITY OF CALIFORNIA DOES NOT WARRANT THAT THE OPERATION OF THE
##	PROGRAM  WILL BE UNINTERRUPTED OR ERROR-FREE. THE END-USER UNDERSTANDS
##	THAT THE PROGRAM  WAS DEVELOPED FOR RESEARCH PURPOSES AND IS ADVISED NOT
##	TO RELY EXCLUSIVELY  ON THE PROGRAM FOR ANY REASON.
##
##	IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
##	DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING
##	LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
##	DOCUMENTATION,  EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF
##	THE POSSIBILITY OF SUCH DAMAGES. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY
##	DISCLAIMS ANY  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
##	WARRANTIES OF  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE
##	SOFTWARE PROVIDED  HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
##	CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
##	ENHANCEMENTS, OR  MODIFICATIONS.

from	Tkinter import *
import	my_tkDialog
import	tkMessageBox

cfg = 'pro.cfg'

def	read(parent):
	try:
		for l in open(cfg).readlines(): exec l

		parent.pro_sample_count = down_sample_interval
		parent.pro_time = duration
		parent.pro_cutoff_voltage = cutoff_voltage
	except:
		parent.pro_sample_count = 100
		parent.pro_time = 600.
		parent.pro_cutoff_voltage = 0.

		write(parent)
		

def	write(parent):
	f = open(cfg, 'w')
	print >> f, 'down_sample_interval =', parent.pro_sample_count
	print >> f, 'duration =', parent.pro_time
	print >> f, 'cutoff_voltage =', parent.pro_cutoff_voltage
	f.close()


class	pro_dlg(my_tkDialog.Dialog):
	def	__init__(self, parent):
		self.count = parent.pro_sample_count
		self.duration = parent.pro_time
		self.voltage = parent.pro_cutoff_voltage
		
		my_tkDialog.Dialog.__init__(self, parent, title = 'Profiling Parameters')


	def	body(self, master):
		Label(master, text = 'Down-sample interval:').grid(row = 0, sticky = W)
		Label(master, text = 'Duration:').grid(row = 1, sticky = W)
		Label(master, text = 'Cutoff voltage:').grid(row = 2, sticky = W)

		self.e1 = Entry(master)
		self.e2 = Entry(master)
		self.e3 = Entry(master)

		self.e1.grid(row = 0, column = 1)
		self.e2.grid(row = 1, column = 1)
		self.e3.grid(row = 2, column = 1)

		self.e1.insert(0, str(self.count))
		self.e2.insert(0, str(self.duration))
		self.e3.insert(0, str(self.voltage))


	def	validate(self):
		try:
			count = int(self.e1.get())
			duration = float(self.e2.get())
			voltage = float(self.e3.get())
		except:
			tkMessageBox.showwarning('Bad input', 'Illegal numerical values')
			return 0
		if count <= 0:
			tkMessageBox.showwarning('Bad input', 'Sample count <= 0')
			return 0
		if duration <= 0:
			tkMessageBox.showwarning('Bad input', 'Duration <= 0')
			return 0
		if voltage < 0:
			tkMessageBox.showwarning('Bad input', 'voltage < 0')
			return 0
		
		self.count = count
		self.duration = duration
		self.voltage = voltage
		return 1


	def	apply(self):
		self.parent.pro_sample_count = self.count
		self.parent.pro_time = self.duration
		self.parent.pro_cutoff_voltage = self.voltage
		
		return self.result



if	__name__ == '__main__':
	global	root

	def	test():
		d = pro_dlg(root, 100, 600)
		print d.result        	

	root = Tk()
	Button(root, text = 'Test', command = test).pack()
	root.mainloop()
