##	Copyright (c) 2004 The Regents of the University of California. All Rights
##	Reserved. Permission to use, copy, modify, and distribute this  software
##	and its documentation for educational, research and non-profit purposes,
##	without fee, and without a written agreement is hereby granted, provided
##	that the above copyright notice, this paragraph and the following two
##	paragraphs appear in all copies. This software program and documentation
##	are copyrighted  by The Regents of the University of California ("The
##	University of California").
##
##	THE SOFTWARE PROGRAM AND DOCUMENTATION ARE SUPPLIED "AS IS," WITHOUT ANY
##	ACCOMPANYING SERVICES FROM THE UNIVERSITY OF CALFORNIA. FURTHERMORE, THE
##	UNIVERSITY OF CALIFORNIA DOES NOT WARRANT THAT THE OPERATION OF THE
##	PROGRAM  WILL BE UNINTERRUPTED OR ERROR-FREE. THE END-USER UNDERSTANDS
##	THAT THE PROGRAM  WAS DEVELOPED FOR RESEARCH PURPOSES AND IS ADVISED NOT
##	TO RELY EXCLUSIVELY  ON THE PROGRAM FOR ANY REASON.
##
##	IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
##	DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING
##	LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
##	DOCUMENTATION,  EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF
##	THE POSSIBILITY OF SUCH DAMAGES. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY
##	DISCLAIMS ANY  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
##	WARRANTIES OF  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE
##	SOFTWARE PROVIDED  HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
##	CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
##	ENHANCEMENTS, OR  MODIFICATIONS.

from	Tkinter import *
import	schart

def	sframe(parent, label, chart_size, window_scale, full_scale, n_chart, curve_color, line_width):
	width, height = chart_size

	xscroll_factor = 1000
	yscroll_factor = 200
	
	frame = Frame(parent, bd = 0, relief = RAISED)

	hscroll = Scrollbar(frame, orient = 'horizontal')
	vscroll = Scrollbar(frame, orient = 'vertical')

	root_canvas_width = width
	root_canvas_height = height
	root_canvas = Canvas(frame, width = root_canvas_width, height = root_canvas_height, bg = '#ffffff')

	chart_canvas_width = root_canvas_width - 100
	chart_canvas_height = root_canvas_height - 100
	chart_canvas = Canvas(root_canvas, width = chart_canvas_width, height = chart_canvas_height,
						  bg = '#ffffff',
						  xscrollcommand = hscroll.set,
						  yscrollcommand = vscroll.set,
						  xscrollincrement = 1,
						  yscrollincrement = 1,
						  highlightthickness = 0,
						  )
	chart_canvas_anchor_x = 50
	chart_canvas_anchor_y = 50
	chart_canvas.place(x = chart_canvas_anchor_x, y = chart_canvas_anchor_y)

	xmark_canvas_width = chart_canvas_width + schart.xmark_offset
	xmark_canvas_height = root_canvas_height - chart_canvas_height - chart_canvas_anchor_y - 1
	xmark_canvas = Canvas(root_canvas, width = xmark_canvas_width, height = xmark_canvas_height,
						  bg = '#ffffff',
						  #xscrollcommand = hscroll.set, # must not set it, since size is different
						  xscrollincrement = 1,
						  highlightthickness = 0,
						  )
	xmark_canvas.place(x = chart_canvas_anchor_x - 1, y = chart_canvas_height + chart_canvas_anchor_y + 1)

	ymark_canvas_width = chart_canvas_anchor_x - 1 - schart.left_padding
	ymark_canvas_height = chart_canvas_height + schart.ymark_offset
	ymark_canvas = Canvas(root_canvas, width = ymark_canvas_width, height = ymark_canvas_height + 1,
						  bg = '#ffffff',
						  #yscrollcommand = vscroll.set, # must not set it, since size is different
						  yscrollincrement = 1,
						  highlightthickness = 0,
						  )
	ymark_canvas.place(x = schart.left_padding, y = chart_canvas_anchor_y - schart.ymark_offset)

	chart = schart.schart(parent,
						  root_canvas,
						  chart_canvas,
						  xmark_canvas,
						  ymark_canvas,
						  (chart_canvas_width, chart_canvas_height),
						  (xmark_canvas_width, xmark_canvas_height),
						  (ymark_canvas_width, ymark_canvas_height),
						  (chart_canvas_anchor_x, chart_canvas_anchor_y),
						  window_scale,
						  full_scale,
						  n_chart,
						  curve_color,
						  line_width)

	hscroll.config(command = chart.xscroll)
	vscroll.config(command = chart.yscroll)

	hscroll.pack(side = BOTTOM, anchor = S, fill = X, expand = 1)
	vscroll.pack(side = RIGHT, anchor = W, fill = Y)

	root_canvas.pack(side = LEFT, fill = 'both', expand = 0)

	frame.pack(side = TOP, fill = BOTH, expand = 1, padx = 1)

	return frame, chart
