##	Copyright (c) 2004 The Regents of the University of California. All Rights
##	Reserved. Permission to use, copy, modify, and distribute this  software
##	and its documentation for educational, research and non-profit purposes,
##	without fee, and without a written agreement is hereby granted, provided
##	that the above copyright notice, this paragraph and the following two
##	paragraphs appear in all copies. This software program and documentation
##	are copyrighted  by The Regents of the University of California ("The
##	University of California").
##
##	THE SOFTWARE PROGRAM AND DOCUMENTATION ARE SUPPLIED "AS IS," WITHOUT ANY
##	ACCOMPANYING SERVICES FROM THE UNIVERSITY OF CALFORNIA. FURTHERMORE, THE
##	UNIVERSITY OF CALIFORNIA DOES NOT WARRANT THAT THE OPERATION OF THE
##	PROGRAM  WILL BE UNINTERRUPTED OR ERROR-FREE. THE END-USER UNDERSTANDS
##	THAT THE PROGRAM  WAS DEVELOPED FOR RESEARCH PURPOSES AND IS ADVISED NOT
##	TO RELY EXCLUSIVELY  ON THE PROGRAM FOR ANY REASON.
##
##	IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
##	DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING
##	LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
##	DOCUMENTATION,  EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF
##	THE POSSIBILITY OF SUCH DAMAGES. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY
##	DISCLAIMS ANY  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
##	WARRANTIES OF  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE
##	SOFTWARE PROVIDED  HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
##	CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
##	ENHANCEMENTS, OR  MODIFICATIONS.

from	Tkinter import *
import	os
import	my_tkDialog
import	tkMessageBox

cfg = 'sim.cfg'

model_suffix = '.model'

def	read(parent):
	try:
		for l in open(cfg).readlines(): exec l

		parent.sim_interval = interval
		parent.sim_time = duration
		parent.sim_model = model
	except:
		parent.sim_interval = 0.5
		parent.sim_time = 600.
		parent.sim_model = 'ipaq'

		write(parent)
		


def	write(parent):
	f = open(cfg, 'w')
	print >> f, 'interval =', parent.sim_interval
	print >> f, 'duration =', parent.sim_time
	print >> f, 'model =', '\"' + parent.sim_model + '\"'
	f.close()


class	sim_dlg(my_tkDialog.Dialog):
	def	__init__(self, parent):
		self.interval = parent.sim_interval
		self.duration = parent.sim_time
		self.modelVar = StringVar()
		self.modelVar.set(parent.sim_model)
		
		my_tkDialog.Dialog.__init__(self, parent, title = 'Simulation Parameters')


	def	body(self, master):
		Label(master, text = 'Interval:').grid(row = 0, sticky = W)
		Label(master, text = 'Duration:').grid(row = 1, sticky = W)
		Label(master, text = 'Battery model:').grid(row = 2, sticky = W)

		self.e1 = Entry(master)
		self.e2 = Entry(master)

		model_file_list = filter(lambda x: x.endswith(model_suffix), os.listdir('.'))
		model_list = map(lambda x: x[: x.index(model_suffix)], model_file_list)

		cmd = 'OptionMenu(master, self.modelVar'
		for model in model_list:
			cmd += ', \"' + model + '\"'
		cmd += ')'

		self.o3 = eval(cmd)		

		self.e1.grid(row = 0, column = 1)
		self.e2.grid(row = 1, column = 1)
		self.o3.grid(row = 2, column = 1)

		self.e1.insert(0, str(self.interval))
		self.e2.insert(0, str(self.duration))


	def	validate(self):
		try:
			interval = float(self.e1.get())
			duration = float(self.e2.get())
		except:
			tkMessageBox.showwarning('Bad input', 'Illegal numerical values')
			return 0
		if interval <= 0:
			tkMessageBox.showwarning('Bad input', 'Interval <= 0')
			return 0
		if duration <= 0:
			tkMessageBox.showwarning('Bad input', 'Duration <= 0')
			return 0
		
		self.interval = interval
		self.duration = duration
		return 1


	def	apply(self):
		self.parent.sim_interval = self.interval
		self.parent.sim_time = self.duration
		self.parent.sim_model = self.modelVar.get()

		return self.result


if	__name__ == '__main__':
	global	root

	def	test():
		d = sim_dlg(root, 0.3, 600)
		print d.result        	

	root = Tk()
	Button(root, text = 'Test', command = test).pack()
	root.mainloop()
