##	Copyright (c) 2004 The Regents of the University of California. All Rights
##	Reserved. Permission to use, copy, modify, and distribute this  software
##	and its documentation for educational, research and non-profit purposes,
##	without fee, and without a written agreement is hereby granted, provided
##	that the above copyright notice, this paragraph and the following two
##	paragraphs appear in all copies. This software program and documentation
##	are copyrighted  by The Regents of the University of California ("The
##	University of California").
##
##	THE SOFTWARE PROGRAM AND DOCUMENTATION ARE SUPPLIED "AS IS," WITHOUT ANY
##	ACCOMPANYING SERVICES FROM THE UNIVERSITY OF CALFORNIA. FURTHERMORE, THE
##	UNIVERSITY OF CALIFORNIA DOES NOT WARRANT THAT THE OPERATION OF THE
##	PROGRAM  WILL BE UNINTERRUPTED OR ERROR-FREE. THE END-USER UNDERSTANDS
##	THAT THE PROGRAM  WAS DEVELOPED FOR RESEARCH PURPOSES AND IS ADVISED NOT
##	TO RELY EXCLUSIVELY  ON THE PROGRAM FOR ANY REASON.
##
##	IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
##	DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING
##	LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
##	DOCUMENTATION,  EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF
##	THE POSSIBILITY OF SUCH DAMAGES. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY
##	DISCLAIMS ANY  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
##	WARRANTIES OF  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE
##	SOFTWARE PROVIDED  HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
##	CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
##	ENHANCEMENTS, OR  MODIFICATIONS.

from	Tkinter import *
import	my_tkDialog
import	tkMessageBox

class	stt_dlg(my_tkDialog.Dialog):
	def	__init__(self, parent, label1, par1, format1, label2, par2, format2):
		self.label1 = label1
		self.par1 = par1
		self.format1 = format1
		self.label2 = label2
		self.par2 = par2
		self.format2 = format2
		my_tkDialog.Dialog.__init__(self, parent, title = 'Statistics', has_cancel = 0, has_apply = 0)


	def	body(self, master):
		#self.parent.setWait()
		
		n1 = len(self.par1)
		n2 = len(self.par2)

		wd = 12

		Label(master, text = '').grid(row = 1, sticky = W)
		for i in range(n1):
			Label(master, text = self.label1[i]).grid(row = 0, column = i + 1, sticky = S)
		for i in range(n2):
			Label(master, text = self.label2[i]).grid(row = 0, column = i + 1 + n1, sticky = S)

		Label(master, text = 'Emulation:').grid(row = 1, sticky = W)
		
		self.e_e1 = []
		for i in range(n1):
			e = Entry(master, width = wd)
			e.grid(row = 1, column = i + 1)
			self.e_e1.append(e)
		self.e_e2 = []
		for i in range(n2):
			e = Entry(master, width = wd)
			e.grid(row = 1, column = i + 1 + n1)
			self.e_e2.append(e)
			
		var = self.parent.extractDataParameter(self.parent.emu_data_file, self.par1)
		if var != None:
			for i in range(n1):
				if var[i] != None:
					if not self.format1[i].endswith('%'):
						s = self.format1[i] % var[i]
					else:
						s = self.format1[i] % (var[i] * 100)
					self.e_e1[i].insert(0, str(s))

		var = self.parent.extractComparedParameter(self.parent.emu_data_file, self.par2)
		if var != None:
			for i in range(n2):
				if var[i] != None:
					if not self.format2[i].endswith('%'):
						s = self.format2[i] % var[i]
					else:
						s = self.format2[i] % (var[i] * 100)
					self.e_e2[i].insert(0, str(s))

		Label(master, text = 'Simulation:').grid(row = 2, sticky = W)

		self.e_s1 = []
		for i in range(n1):
			e = Entry(master, width = wd)
			e.grid(row = 2, column = i + 1)
			self.e_s1.append(e)
		self.e_s2 = []
		for i in range(n2):
			e = Entry(master, width = wd)
			e.grid(row = 2, column = i + 1 + n1)
			self.e_s2.append(e)
			
		var = self.parent.extractDataParameter(self.parent.sim_data_file, self.par1)
		if var != None:
			for i in range(n1):
				if var[i] != None:
					if not self.format1[i].endswith('%'):
						s = self.format1[i] % var[i]
					else:
						s = self.format1[i] % (var[i] * 100)
					self.e_s1[i].insert(0, str(s))

		var = self.parent.extractComparedParameter(self.parent.sim_data_file, self.par2)
		if var != None:
			for i in range(n2):
				if var[i] != None:
					if not self.format2[i].endswith('%'):
						s = self.format2[i] % var[i]
					else:
						s = self.format2[i] % (var[i] * 100)
					self.e_s2[i].insert(0, str(s))
				

		Label(master, text = 'Post-profiling:').grid(row = 3, sticky = W)

		self.e_pp1 = []
		for i in range(n1):
			e = Entry(master, width = wd)
			e.grid(row = 3, column = i + 1)
			self.e_pp1.append(e)
		self.e_pp2 = []
		for i in range(n2):
			e = Entry(master, width = wd)
			e.grid(row = 3, column = i + 1 + n1)
			self.e_pp2.append(e)
			
		var = self.parent.extractDataParameter(self.parent.pos_data_file, self.par1)
		if var != None:
			for i in range(n1):
				if var[i] != None:
					if not self.format1[i].endswith('%'):
						s = self.format1[i] % var[i]
					else:
						s = self.format1[i] % (var[i] * 100)
					self.e_pp1[i].insert(0, str(s))

		var = self.parent.extractComparedParameter(self.parent.pos_data_file, self.par2)
		if var != None:
			for i in range(n2):
				if var[i] != None:
					if not self.format2[i].endswith('%'):
						s = self.format2[i] % var[i]
					else:
						s = self.format2[i] % (var[i] * 100)
					self.e_pp2[i].insert(0, str(s))
				
		Label(master, text = 'Profiling:').grid(row = 4, sticky = W)

		self.e_p1 = []
		for i in range(n1):
			e = Entry(master, width = wd)
			e.grid(row = 4, column = i + 1)
			self.e_p1.append(e)
		self.e_p2 = []
		for i in range(n2):
			e = Entry(master, width = wd)
			e.grid(row = 4, column = i + 1 + n1)
			self.e_p2.append(e)
			
		var = self.parent.extractDataParameter(self.parent.pro_data_file, self.par1)
		if var != None:
			for i in range(n1):
				if var[i] != None:
					if not self.format1[i].endswith('%'):
						s = self.format1[i] % var[i]
					else:
						s = self.format1[i] % (var[i] * 100)
					self.e_p1[i].insert(0, str(s))

		for e_list in (self.e_e1, self.e_e2, self.e_s1, self.e_s2, self.e_pp1, self.e_pp2, self.e_p1):
			for e in e_list:
				e.config(state = DISABLED)


		#self.parent.clearWait()



if	__name__ == '__main__':
	global	root

	def	test():
		d = stt_dlg(root, 0.3, 30, 600)
		print d.result        	

	root = Tk()
	Button(root, text = 'Test', command = test).pack()
	root.mainloop()
